﻿local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 38955 $"):match("%d+"))

if MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

ThreatLib_funcs[#ThreatLib_funcs+1] = function()

local ThreatLib = _G.ThreatLib

local BB = AceLibrary("Babble-Boss-2.2")

-- You need to register the module with the localized mob name, as this is used to 
local c = BB["Terestian Illhoof"]

local ThreatLibNPCModuleCore = ThreatLib:GetModule("NPCCore")
local Illhoof = ThreatLibNPCModuleCore:NewModule(c)

Illhoof:RegisterTranslation("enUS", {
	["Kil'rek"] = "Kil'rek",
})
Illhoof:RegisterTranslation("deDE", {
	["Kil'rek"] = nil
})
Illhoof:RegisterTranslation("frFR", {
	["Kil'rek"] = nil
})
Illhoof:RegisterTranslation("koKR", {
	["Kil'rek"] = "킬렉"
})
Illhoof:RegisterTranslation("koKR", {
	["Kil'rek"] = nil
})

local impName = Illhoof:GetTranslation("Kil'rek")

Illhoof:UnregisterTranslations()

function Illhoof:Init()
	if impName then
		self:RegisterCombatant(impName, self.clearKilrekThreat)
	end
	self:RegisterCombatant(BB["Terestian Illhoof"], true)
end

function Illhoof:StartFight()
	self:SetNumberOfMobs(1)
end

function Illhoof:clearKilrekThreat()
	self:WipeRaidThreatOnMob(impName)
end

end