﻿local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 38955 $"):match("%d+"))

if MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

ThreatLib_funcs[#ThreatLib_funcs+1] = function()

local ThreatLib = _G.ThreatLib

local BB = AceLibrary("Babble-Boss-2.2")

-- You need to register the module with the localized mob name, as this is used to 
local c = BB["Magtheridon"]

local Magtheridon = ThreatLib:GetModule("NPCCore"):NewModule(c)

Magtheridon:RegisterTranslation("enUS", {
	["I... am... unleashed!"] = "I... am... unleashed!",
	["Hellfire Channeler"] = "Hellfire Channeler"
})

Magtheridon:RegisterTranslation("deDE", {
	["I... am... unleashed!"] = "Ich... bin... frei!",
	["Hellfire Channeler"] = nil
})

Magtheridon:RegisterTranslation("frFR", {
	["I... am... unleashed!"] = "Me... voilà... déchaîné !",
	["Hellfire Channeler"] = nil
})

Magtheridon:RegisterTranslation("koKR", {
	["I... am... unleashed!"] = "내가... 풀려났도다!",
	["Hellfire Channeler"] = "지옥불 역술사"
})

Magtheridon:RegisterTranslation("zhTW", {
	["I... am... unleashed!"] = "Ich... bin... frei!",
	["Hellfire Channeler"] = nil
})

local magPhase = Magtheridon:GetTranslation("I... am... unleashed!")
local channelerName = Magtheridon:GetTranslation("Hellfire Channeler")

Magtheridon:UnregisterTranslations()

function Magtheridon:Init()
	
	-- You can register Joe The Noob as a combatant in this fight, and set a handler to be called on his death
	-- self:RegisterCombatant(BB["Joe the Noob"], self.HandleJoeDeath)
	
	-- Alternately, if the second parameter is true, then the fight is over when Joe dies.
	-- self:RegisterCombatant(BB["Joe the Noob"], true)

	self:RegisterCombatant(BB["Magtheridon"], true)
	
	if channelerName then
		self:RegisterCombatant(channelerName, self.ChannelerDeath)
		channelerNames = nil
	end

	-- To register a callback to a yell or emote:
	-- self:RegisterChatEvent([yell|event], localizedMobName, yellOrEmoteToTriggerOn, callbackFunction)
	-- self:RegisterChatEvent("yell", BB["Attumen the Huntsman"], phaseThree, self.PhaseThree)
	
	self:RegisterChatEvent("yell", BB["Magtheridon"], magPhase, self.phaseTransition)
end

function Magtheridon:StartFight()
	if self.channelerName then		-- We have a localization for the channelers, so we can tell when they die
		self:SetNumberOfMobs(6)
	else							-- We have no localization for the channelers, so just assume a single mob - Mag himself
		self:SetNumberOfMobs(1)
	end
end

function Magtheridon:ChannelerDeath()
	self:SetNumberOfMobs(self:GetNumberOfMobs() - 1)
end

function Magtheridon:phaseTransition()
	self:SetNumberOfMobs(1)
	self:WipeRaidThreatOnMob(BB["Magtheridon"])
end

table.insert(ThreatLib.UpvalueFixers, function(lib)
	ThreatLib = lib
	Magtheridon = ThreatLib:GetModule("NPCCore"):GetModule(c)
end)

end
