﻿local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 38955 $"):match("%d+"))

if MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

ThreatLib_funcs[#ThreatLib_funcs+1] = function()

local ThreatLib = _G.ThreatLib

local BB = AceLibrary("Babble-Boss-2.2")

-- You need to register the module with the localized mob name, as this is used to 
local c = BB["Hydross the Unstable"]

local Hydross = ThreatLib:GetModule("NPCCore"):NewModule(c)

Hydross:RegisterTranslation("enUS", {
	["Aaghh, the poison..."] = "Aaghh, the poison...",
	["Better, much better."] = "Better, much better.",
	["Tainted Spawn of Hydross"] = "Tainted Spawn of Hydross",
	["Pure Spawn of Hydross"] = "Pure Spawn of Hydross"
})

Hydross:RegisterTranslation("deDE", {
	["Aaghh, the poison..."] = "Aahh, das Gift...",
	["Better, much better."] = "Besser, viel besser.",
	["Tainted Spawn of Hydross"] = nil,
	["Pure Spawn of Hydross"] = nil
})

Hydross:RegisterTranslation("frFR", {
	["Aaghh, the poison..."] = "Aaarrgh, le poison…",
	["Better, much better."] = "Ça va mieux. Beaucoup mieux.",
	["Tainted Spawn of Hydross"] = nil,
	["Pure Spawn of Hydross"] = nil
})

Hydross:RegisterTranslation("koKR", {
	["Aaghh, the poison..."] = "으아아, 독이...",
	["Better, much better."] = "아... 기분이 훨씬 좋군.",
	["Tainted Spawn of Hydross"] = "오염된 히드로스의 피조물",
	["Pure Spawn of Hydross"] = "순수한 히드로스의 피조물"
})

Hydross:RegisterTranslation("koKR", {
	["Aaghh, the poison..."] = nil,
	["Better, much better."] = nil,
	["Tainted Spawn of Hydross"] = nil,
	["Pure Spawn of Hydross"] = nil
})

local poisonPhase = Hydross:GetTranslation("Aaghh, the poison...")
local waterPhase = Hydross:GetTranslation("Better, much better.")
local pureSpawnName = Hydross:GetTranslation("Tainted Spawn of Hydross")
local taintedSpawnName = Hydross:GetTranslation("Pure Spawn of Hydross")

Hydross:UnregisterTranslations()

function Hydross:Init()
	
	self:RegisterCombatant(BB["Hydross the Unstable"], true)
	
	if pureSpawnName and taintedSpawnName then
		self:RegisterCombatant(pureSpawnName, self.spawnDeath)
		self:RegisterCombatant(taintedSpawnName, self.spawnDeath)
	end

	self:RegisterChatEvent("yell", BB["Hydross the Unstable"], poisonPhase, self.phaseTransition)
	self:RegisterChatEvent("yell", BB["Hydross the Unstable"], waterPhase, self.phaseTransition)
end

function Hydross:StartFight()
	self:SetNumberOfMobs(1)
end

function Hydross:spawnDeath()
	self:SetNumberOfMobs(self:GetNumberOfMobs() - 1)
end

function Hydross:phaseTransition()
	self:SetNumberOfMobs(5)		-- Hydross + 4 spawns
	self:WipeRaidThreatOnMob(BB["Hydross the Unstable"])
	self:WipeRaidThreatOnMob(pureSpawnName)
	self:WipeRaidThreatOnMob(taintedSpawnName)
end

table.insert(ThreatLib.UpvalueFixers, function(lib)
	ThreatLib = lib
	Hydross = ThreatLib:GetModule("NPCCore"):GetModule(c)
end)

end
