﻿local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 38970 $"):match("%d+"))

if MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

ThreatLib_funcs[#ThreatLib_funcs+1] = function()

local ThreatLib = _G.ThreatLib

local BB = AceLibrary("Babble-Boss-2.2")

-- You need to register the module with the localized mob name, as this is used to 
local c = BB["Morogrim Tidewalker"]

local Morogrim = ThreatLib:GetModule("NPCCore"):NewModule(c)

Morogrim:RegisterTranslation("enUS", {
	["Murlocs"] = "Murlocs",
	["Tidewalker Lurker"] = "Tidewalker Lurker"
})

Morogrim:RegisterTranslation("deDE", {
	["Murlocs"] = "Murlocs",
	["Tidewalker Lurker"] = nil
})

Morogrim:RegisterTranslation("frFR", {
	["Murlocs"] = "Murlocs",
	["Tidewalker Lurker"] = nil
})

Morogrim:RegisterTranslation("koKR", {
	["Murlocs"] = "멀록들",
	["Tidewalker Lurker"] = nil
})

Morogrim:RegisterTranslation("zhTW", {
	["Murlocs"] = nil,
	["Tidewalker Lurker"] = nil
})

local murlocPhase = Morogrim:GetTranslation("Murlocs")
local murlocName = Morogrim:GetTranslation("Tidewalker Lurker")

Morogrim:UnregisterTranslations()

function Morogrim:Init()
	self:RegisterCombatant(BB["Morogrim Tidewalker"], true)
	
	if murlocName then
		self:RegisterCombatant(murlocName, self.murlocDeath)
	end
	
	if murlocPhase then
			self:RegisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
	end
end

function Morogrim:StartFight()
	-- SetNumberOfMobs is used as a divisor for global threat. Be sure to set it correctly, and to account for mob deaths during the fight
	-- If you are unsure of the participants, or you want to just be safe, leave this at 1
	self:SetNumberOfMobs(1)
end

function Morogrim:murlocDeath()
	self:SetNumberOfMobs(self:GetNumberOfMobs() - 1)
end

function Morogrim:CHAT_MSG_RAID_BOSS_EMOTE(msg)
	if msg:find(murlocPhase) then
		self:SetNumberOfMobs(self:GetNumberOfMobs() + 12)	-- Morogrim + 12 murlocs (two packs of six)
		self:WipeRaidThreatOnMob(murlocName)
	end
end



table.insert(ThreatLib.UpvalueFixers, function(lib)
	ThreatLib = lib
	Morogrim = ThreatLib:GetModule("NPCCore"):GetModule(c)
end)

end
