﻿local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 38530 $"):match("%d+"))

if MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

ThreatLib_funcs[#ThreatLib_funcs+1] = function()

local ThreatLib = _G.ThreatLib

local BB = AceLibrary("Babble-Boss-2.2")

-- You need to register the module with the localized mob name, as this is used to 
local c = BB["Lady Vashj"]

local Vashj = ThreatLib:GetModule("NPCCore"):NewModule(c)

Vashj:RegisterTranslation("enUS", {
	["Coilfang Elite"] = "Coilfang Elite",
	["Coilfang Strider"] = "Coilfang Strider"
})
Vashj:RegisterTranslation("deDE", {
	["Coilfang Elite"] = nil,
	["Coilfang Strider"] = nil,
})
Vashj:RegisterTranslation("frFR", {
	["Coilfang Elite"] = nil,
	["Coilfang Strider"] = nil,
})
Vashj:RegisterTranslation("koKR", {
	["Coilfang Elite"] = nil,
	["Coilfang Strider"] = nil,
})
Vashj:RegisterTranslation("zhTW", {
	["Coilfang Elite"] = nil,
	["Coilfang Strider"] = nil,
})

local eliteName = Vashj:GetTranslation("Coilfang Elite")
local striderName = Vashj:GetTranslation("Coilfang Strider")

Vashj:UnregisterTranslations()

function Vashj:Init()
	self:RegisterCombatant(BB["Lady Vashj"], true)
	
	if eliteName then
		self:RegisterCombatant(eliteName, self.eliteDeath)
	end
	
	if striderName then
		self:RegisterCombatant(striderName, self.striderDeath)
	end
end

function Vashj:StartFight()
	-- SetNumberOfMobs is used as a divisor for global threat. Be sure to set it correctly, and to account for mob deaths during the fight
	-- If you are unsure of the participants, or you want to just be safe, leave this at 1
	self:SetNumberOfMobs(1)
end

function Vashj:eliteDeath()
	self:WipeRaidThreatOnMob(eliteName)
end

function Vashj:striderDeath()
	self:WipeRaidThreatOnMob(striderName)
end


table.insert(ThreatLib.UpvalueFixers, function(lib)
	ThreatLib = lib
	Vashj = ThreatLib:GetModule("NPCCore"):GetModule(c)
end)

end
