﻿local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 38535 $"):match("%d+"))

if MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

ThreatLib_funcs[#ThreatLib_funcs+1] = function()

local ThreatLib = _G.ThreatLib

local BB = AceLibrary("Babble-Boss-2.2")

-- You need to register the module with the localized mob name, as this is used to
local c = BB["Kael'thas Sunstrider"]

local Kaelthas = ThreatLib:GetModule("NPCCore"):NewModule(c)

Kaelthas:RegisterTranslation("enUS", {
	["Impressive. Let us see how your nerves hold up against the Darkener, Thaladred!"] = true,
	["You have persevered against some of my best advisors... but none can withstand the might of the Blood Hammer. Behold, Lord Sanguinar!"] = true,
	["Capernian will see to it that your stay here is a short one."] = true,
	["Well done, you have proven worthy to test your skills against my master engineer, Telonicus."] = true,
	["Perhaps I underestimated you. It would be unfair to make you fight all four advisors at once, but... fair treatment was never shown to my people. I'm just returning the favor."] = true,
	["As you see, I have many weapons in my arsenal...."] = true,
	["Alas, sometimes one must take matters into one's own hands. Balamore shanal!"] = true,
	["Devastation"] = true,
	["Cosmic Infuser"] = true,
	["Infinity Blades"] = true,
	["Staff of Disintegration"] = true,
	["Warp Slicer"] = true,
	["Netherstrand Longbow"] = true,
	["Phaseshift Bulwark"] = true
})

Kaelthas:RegisterTranslation("deDE", {
	["Impressive. Let us see how your nerves hold up against the Darkener, Thaladred!"] = "Eindrucksvoll. Aber werdet Ihr auch mit Thaladred, dem Verfinsterer fertig?",
	["You have persevered against some of my best advisors... but none can withstand the might of the Blood Hammer. Behold, Lord Sanguinar!"] = "Ihr habt gegen einige meiner besten Berater bestanden... aber niemand kommt gegen die Macht des Bluthammers an. Zittert vor F\195\188rst Blutdurst!",
	["Capernian will see to it that your stay here is a short one."] = "Capernian wird daf\195\188r sorgen, dass Euer Aufenthalt hier nicht lange w\195\164hrt.",
	["Well done, you have proven worthy to test your skills against my master engineer, Telonicus."] = "Gut gemacht. Ihr habt Euch w\195\188rdig erwiesen, gegen meinen Meisteringenieur, Telonicus, anzutreten.",
	["Perhaps I underestimated you. It would be unfair to make you fight all four advisors at once, but... fair treatment was never shown to my people. I'm just returning the favor."] = "Vielleicht habe ich Euch untersch\195\164tzt. Es w\195\164re unfair, Euch gegen meine vier Berater gleichzeitig k\195\164mpfen zu lassen, aber... mein Volk wurde auch nie fair behandelt. Ich vergelte nur Gleiches mit Gleichem.",
	["As you see, I have many weapons in my arsenal...."] = "Wie Ihr seht, habe ich viele Waffen in meinem Arsenal...",
	["Alas, sometimes one must take matters into one's own hands. Balamore shanal!"] = "Ach, manchmal muss man die Sache selbst in die Hand nehmen. Balamore shanal!",
	["Devastation"] = "Verw\195\188stung",
	["Cosmic Infuser"] = "Kosmische Macht",
	["Infinity Blades"] = "Klinge der Unendlichkeit",
	["Staff of Disintegration"] = "Stab der Aufl\195\182sung",
	["Warp Slicer"] = "Warpschnitter",
	["Netherstrand Longbow"] = "Netherbespannter Langbogen",
	["Phaseshift Bulwark"] = "Phasenverschobenes Bollwerk"
})

Kaelthas:RegisterTranslation("frFR", {
	["Impressive. Let us see how your nerves hold up against the Darkener, Thaladred!"] = "Impressionnant. Voyons comment tiendront vos nerfs face à l'Assombrisseur, Thaladred !",
	["You have persevered against some of my best advisors... but none can withstand the might of the Blood Hammer. Behold, Lord Sanguinar!"] = "Vous avez tenu tête à certains de mes plus talentueux conseillers… mais personne ne peut résister à la puissance du Marteau de sang. Je vous présente, le seigneur Sanguinar !",
	["Capernian will see to it that your stay here is a short one."] = "Capernian fera en sorte que votre séjour ici ne se prolonge pas.",
	["Well done, you have proven worthy to test your skills against my master engineer, Telonicus."] = "Bien, vous êtes digne de mesurer votre talent à celui de mon maître ingénieur, Telonicus.",
	["Perhaps I underestimated you. It would be unfair to make you fight all four advisors at once, but... fair treatment was never shown to my people. I'm just returning the favor."] = "Peut-être vous ai-je sous-estimés. Il ne serait pas très loyal de vous faire combattre mes quatres conseillers en même temps, mais… mon peuple n'a jamais été traîté avec loyauté. Je ne fais que rendre la politesse.",
	["As you see, I have many weapons in my arsenal...."] = "Comme vous le voyez, j'ai plus d'une corde à mon arc…",
	["Alas, sometimes one must take matters into one's own hands. Balamore shanal!"] = "Il est hélas parfois nécessaire de prendre les choses en main soi-même. Balamore shanal !",
	["Devastation"] = "Dévastation",
	["Cosmic Infuser"] = "Bâton d'infusion cosmique",
	["Infinity Blades"] = "Lames d'infinité",
	["Staff of Disintegration"] = "Bâton de désintégration",
	["Warp Slicer"] = "Tranchoir dimensionnel",
	["Netherstrand Longbow"] = "Arc long brins-de-Néant",
	["Phaseshift Bulwark"] = "Rempart de déphasage"
})

Kaelthas:RegisterTranslation("koKR", {
	["Impressive. Let us see how your nerves hold up against the Darkener, Thaladred!"] = "암흑의 인도자 탈라드레드를 상대로 얼마나 버틸지 볼까?",
	["You have persevered against some of my best advisors... but none can withstand the might of the Blood Hammer. Behold, Lord Sanguinar!"] = "최고의 조언가를 상대로 잘도 버텨냈군. 허나 그 누구도 붉은 망치의 힘에는 대항할 수 없지. 보아라, 군주 생귀나르를!",
	["Capernian will see to it that your stay here is a short one."] = "카퍼니안, 놈들이 여기 온 것을 후회하게 해 줘라.",
	["Well done, you have proven worthy to test your skills against my master engineer, Telonicus."] = "좋아, 그 정도 실력이면 수석기술자 텔로니쿠스를 상대해 볼만하겠어.",
	["Perhaps I underestimated you. It would be unfair to make you fight all four advisors at once, but... fair treatment was never shown to my people. I'm just returning the favor."] = "네놈들을 과소평가했나 보군. 모두를 한꺼번에 상대하라는 건 불공평한 처사지. 나의 백성도 공평한 대접을 받은 적 없기는 매한가지. 받은 대로 돌려주겠다.",
	["As you see, I have many weapons in my arsenal...."] = "보다시피 내 무기고엔 굉장한 무기가 아주 많지.",
	["Alas, sometimes one must take matters into one's own hands. Balamore shanal!"] = nil,
	["Devastation"] = "황폐의 도끼",
	["Cosmic Infuser"] = "붕괴의 지팡이",
	["Infinity Blades"] = "무한의 비수",
	["Staff of Disintegration"] = "우주 에너지 주입기",
	["Warp Slicer"] = "차원의 절단기",
	["Netherstrand Longbow"] = "황천매듭 장궁",
	["Phaseshift Bulwark"] = "위상 변화의 보루방패",
})

Kaelthas:RegisterTranslation("zhTW", {
	["Impressive. Let us see how your nerves hold up against the Darkener, Thaladred!"] = nil,
	["You have persevered against some of my best advisors... but none can withstand the might of the Blood Hammer. Behold, Lord Sanguinar!"] = nil,
	["Capernian will see to it that your stay here is a short one."] = nil,
	["Well done, you have proven worthy to test your skills against my master engineer, Telonicus."] = nil,
	["Perhaps I underestimated you. It would be unfair to make you fight all four advisors at once, but... fair treatment was never shown to my people. I'm just returning the favor."] = nil,
	["As you see, I have many weapons in my arsenal...."] = nil,
	["Alas, sometimes one must take matters into one's own hands. Balamore shanal!"] = nil,
	["Devastation"] = nil,
	["Cosmic Infuser"] = nil,
	["Infinity Blades"] = nil,
	["Staff of Disintegration"] = nil,
	["Warp Slicer"] = nil,
	["Netherstrand Longbow"] = nil,
	["Phaseshift Bulwark"] = nil
})

local thaladredTrigger = Kaelthas:GetTranslation("Impressive. Let us see how your nerves hold up against the Darkener, Thaladred!")
local sanguinarTrigger = Kaelthas:GetTranslation("You have persevered against some of my best advisors... but none can withstand the might of the Blood Hammer. Behold, Lord Sanguinar!")
local capernianTrigger = Kaelthas:GetTranslation("Capernian will see to it that your stay here is a short one.")
local telonicusTrigger = Kaelthas:GetTranslation("Well done, you have proven worthy to test your skills against my master engineer, Telonicus.")
local allAdvisorsTrigger = Kaelthas:GetTranslation("Perhaps I underestimated you. It would be unfair to make you fight all four advisors at once, but... fair treatment was never shown to my people. I'm just returning the favor.")
local weaponTrigger = Kaelthas:GetTranslation("As you see, I have many weapons in my arsenal....")
local kaelTrigger = Kaelthas:GetTranslation("Alas, sometimes one must take matters into one's own hands. Balamore shanal!")

Kaelthas:UnregisterTranslations()

local weaponName = {
	["Devastation"] = Kaelthas:GetTranslation("Devastation"),
	["Cosmic Infuser"] = Kaelthas:GetTranslation("Cosmic Infuser"),
	["Infinity Blades"] = Kaelthas:GetTranslation("Infinity Blades"),
	["Staff of Disintigration"] = Kaelthas:GetTranslation("Staff of Disintigration"),
	["Warp Slicer"] = Kaelthas:GetTranslation("Warp Slicer"),
	["Netherstrand Longbow"] = Kaelthas:GetTranslation("Netherstrand Longbow"),
	["Phaseshift Bulwark"] = Kaelthas:GetTranslation("Phaseshift Bulwark")
}

local advisorDeathCount = 0
local weaponDeathCount = 0

function Kaelthas:Init()
	self:RegisterCombatant(BB["Kael'thas Sunstrider"], true)
	self:RegisterCombatant(BB["Thaladred the Darkener"], self.advisorDeath)
	self:RegisterCombatant(BB["Lord Sanguinar"], self.advisorDeath)
	self:RegisterCombatant(BB["Grand Astromancer Capernian"], self.advisorDeath)
	self:RegisterCombatant(BB["Master Engineer Telonicus"], self.advisorDeath)

	if weaponName["Devastation"] and weaponName["Cosmic Infuser"] and weaponName["Infinity Blades"] and weaponName["Staff of Disintigration"] and weaponName["Warp Slicer"] and weaponName["Netherstrand Longbow"] and weaponName["Phaseshift Bulwark"] then
		self:RegisterCombatant(weaponName["Devastation"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Cosmic Infuser"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Infinity Blades"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Staff of Disintigration"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Warp Slicer"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Netherstrand Longbow"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Phaseshift Bulwark"], self.weaponDeath)
	end
	-- To register a callback to a yell or emote:
	-- self:RegisterChatEvent([yell|event], localizedMobName, yellOrEmoteToTriggerOn, callbackFunction)

	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], thaladredTrigger, self.advisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], sanguinarTrigger, self.advisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], capernianTrigger, self.advisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], telonicusTrigger, self.advisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], weaponTrigger, self.weaponTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], allAdvisorsTrigger, self.allAdvisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], kaelTrigger, self.kaelTransition)
end

function Kaelthas:StartFight()
	self:SetNumberOfMobs(1)
end

function Kaelthas:advisorDeath(victimName, killerName)
	self:WipeThreatOnMob(victimName)
	self:SetNumberOfMobs(self:GetNumberOfMobs() - 1)
	advisorDeathCount = advisorDeathCount + 1
end

function Kaelthas:weaponDeath(victimName, killerName)
	self:WipeThreatOnMob(victimName)
	self:SetNumberOfMobs(self:GetNumberOfMobs() - 1)
	weaponDeathCount = weaponDeathCount + 1
end

function Kaelthas:advisorTransition()
	self:SetNumberOfMobs(1)
	self:WipeRaidThreatOnMob(BB["Thaladred the Darkener"])
	self:WipeRaidThreatOnMob(BB["Lord Sanguinar"])
	self:WipeRaidThreatOnMob(BB["Grand Astromancer Capernian"])
	self:WipeRaidThreatOnMob(BB["Master Engineer Telonicus"])
end

function Kaelthas:weaponTransition()
	self:SetNumberOfMobs(7)
	weaponDeathCount = 0
end

function Kaelthas:allAdvisorTransition()
	if weaponDeathCount == 7 then
		self:SetNumberOfMobs(4)
	else
		self:SetNumberOfMobs(self:GetNumberOfMobs() + 4)
	end
	advisorDeathCount = 0
	self:WipeRaidThreatOnMob(BB["Thaladred the Darkener"])
	self:WipeRaidThreatOnMob(BB["Lord Sanguinar"])
	self:WipeRaidThreatOnMob(BB["Grand Astromancer Capernian"])
	self:WipeRaidThreatOnMob(BB["Master Engineer Telonicus"])
end

function Kaelthas:kaelTransition()
	if weaponDeathCount == 7 and advisorDeathCount == 4 then
		self:SetNumberOfMobs(1)
	else
		self:SetNumberOfMobs(self:GetNumberOfMobs() + 1)
	end
	self:WipeRaidThreatOnMob(BB["Kael'thas Sunstrider"])
end

table.insert(ThreatLib.UpvalueFixers, function(lib)
	ThreatLib = lib
	Kaelthas = ThreatLib:GetModule("NPCCore"):GetModule(c)
end)

end